using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;


namespace SMSAPI
{
    [InterfaceTypeAttribute(ComInterfaceType.InterfaceIsDual)]
    public interface iSMSAPIClass
    {
        GenericRetObject Balance(string username, string password);
        GenericRetObject SMSStatus(string username, string password, string refid);
        RetObject SMSSend(string username, string password, string from, string to, string txt);
        RetObject SMSSendObject(string username, string password, SMSSend.SMSObject sms);
        RetObject[] SMSSendObjectArray(string username, string password, SMSSend.SMSObject[] sms);
        Row[] ReportGetSummary(string username, string password, string date_from, string date_to);
        Row[] ReportGet(string username, string password, string date_from, string date_to, int offset, int limit);

        String webproxy_username { set;}
        String webproxy_password { set;}
    }

    public class SMSAPIClass : iSMSAPIClass
    {
        SMSSend.SMSSender s = null;
        public SMSAPIClass()
        {
            this.s = Globals.SMS_ssl();
        }

        public string webproxy_username
        {
            set
            {
                Globals.Proxy_username = value;
            }
        }

        public string webproxy_password
        {
            set
            {
                Globals.Proxy_password = value;
            }
        }

        public GenericRetObject Balance(string username, string password)
        {
            SMSSend.GenericRetObject _ret = this.s.Balance(username, password);
            GenericRetObject ret = new GenericRetObject();
            ret.Description = _ret.Description;
            ret.Status = _ret.Status;
            ret.val = _ret.val;
            return ret;
        }

        public GenericRetObject SMSStatus(string username, string password, string refid)
        {
            SMSSend.GenericRetObject _ret = this.s.SMSStatus(username, password, refid);
            GenericRetObject ret = new GenericRetObject();
            ret.Description = _ret.Description;
            ret.Status = _ret.Status;
            ret.val = _ret.val;
            return ret;
        }

        public RetObject SMSSend(string username, string password, string from, string to, string txt)
        {

            SMSSend.RetObject _ret = this.s.SMSSend(username, password, from, to, txt);
            RetObject ret = new RetObject();
            ret.Description = _ret.Description;
            ret.Status = _ret.Status;
            ret.smsid = _ret.smsid;
            ret.refid = _ret.refid;
            return ret;
        }

        public RetObject SMSSendObject(string username, string password, SMSSend.SMSObject sms)
        {
            SMSSend.RetObject _ret = this.s.SMSSendObject(username, password, sms);
            RetObject ret = new RetObject();
            ret.Description = _ret.Description;
            ret.Status = _ret.Status;
            ret.smsid = _ret.smsid;
            ret.refid = _ret.refid;
            return ret;
        }
        public RetObject[] SMSSendObjectArray(string username, string password, SMSSend.SMSObject[] sms)
        {
            SMSSend.RetObject[] _ret = this.s.SMSSendObjectArray(username, password, sms);
            RetObject[] ret = new RetObject[_ret.Length];
            for (int i = 0; i < _ret.Length; i++)
            {
                RetObject r = new RetObject();
                r.Description = _ret[i].Description;
                r.Status = _ret[i].Status;
                r.smsid = _ret[i].smsid;
                r.refid = _ret[i].refid;
                ret[i] = r;
            }
            return ret;
        }
        public Row[] ReportGetSummary(string username, string password, string date_from, string date_to)
        {
            SMSSend.Row[] _ret = this.s.ReportGetSummary(username, password, date_from, date_to);
            Row[] ret = new Row[_ret.Length];
            for (int i = 0; i < _ret.Length; i++)
            {
                Row r = new Row();
                r.fields = _ret[i].fields;
                r.items = _ret[i].items;
                ret[i] = r;
            }
            return ret;
        }
        public Row[] ReportGet(string username, string password, string date_from, string date_to, int offset, int limit)
        {
            SMSSend.Row[] _ret = this.s.ReportGet(username, password, date_from, date_to, offset, limit);
            Row[] ret = new Row[_ret.Length];
            for (int i = 0; i < _ret.Length; i++)
            {
                Row r=new Row();
                r.fields = _ret[i].fields;
                r.items = _ret[i].items;
                ret[i] = r;
            }
            return ret;
            
        }
        
    }
}
