using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Collections;
using SMSManager.SMSSend;

namespace SMSManager
{
    public partial class frmImportCSV : Form
    {
        AutoResetEvent wait = null;
        bool is_running = false;
        public object[] par;
        DataTable tbl;
        bool is_import_running = false;
        DataTable tbl_err = null;
        
        public frmImportCSV()
        {
            InitializeComponent();
        }

        private void frmImportCSV_Load(object sender, EventArgs e)
        {
            lst_delim.SelectedIndex = 0;
            lst_header.SelectedIndex = 0;
            lst_typ.SelectedIndex = 0;
            //layout.ApplyDefaultLayout(this);
        }

        private void frmImportCSV_Resize(object sender, EventArgs e)
        {
            tabControl1.Width = this.Width;
            tabControl1.Height = this.Height;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Multiselect = false;
            openFileDialog.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            openFileDialog.Filter = "plik csv (*.CSV)|*.csv|plik txt (*.TXT)|*.txt";
            if (openFileDialog.ShowDialog(this) == DialogResult.OK)
            {
                if (openFileDialog.FileName.Trim() == "")
                    MessageBox.Show("Nie wybrano pliku");
                else
                {
                    txt_fielname.Text = openFileDialog.FileName;
                    LoadFile();
                }
            }
            else
                MessageBox.Show("Anulowano");
        }

        private void LoadFile()
        {
            Cursor c = Cursor.Current;
            this.Refresh();
            clear_list();
            ThreadStart ts = new ThreadStart(LoadFileTh);
            Thread th = new Thread(ts);
            wait = new AutoResetEvent(true);
            is_running = true;
            par = new object[] { txt_fielname.Text, char.Parse(lst_delim.SelectedItem.ToString()), ((lst_header.SelectedItem.ToString() == "Tak") ? true : false) };
            th.Start();
            Cursor.Current = Cursors.WaitCursor;
            int i = 0;
            while (is_running)
            {
                Globals.ProgressBarShow(i);
                i = i + 10;

                wait.WaitOne(100, false);
            }
            Globals.ProgressBarShow(90);
            dataGridView_file_preview.DataSource = tbl;
            add_to_list("<ignoruj>");
            if (tbl != null && tbl.Columns != null)
            {
                foreach (DataColumn dtc in tbl.Columns)
                {
                    add_to_list(dtc.ColumnName.ToString());
                }
            }

            Globals.ProgressBarShow(100);
            Globals.ProgressBarHide();
            Cursor.Current = c;
        }
        private void clear_list()
        {
            for (int i = 1; i <= 7; i++)
            {
                Control[] c = tabControl1.TabPages[1].Controls.Find("l" + i.ToString(), false);
                if (c.Length == 0)
                    continue;
                ComboBox l = (ComboBox)c[0];
                l.Items.Clear();
            }
        }
        private void add_to_list(string column)
        {
            for (int i = 1; i <= 7; i++)
            {
                Control[] c = tabControl1.TabPages[1].Controls.Find("l" + i.ToString(), false);
                if (c.Length == 0)
                    continue;
                ComboBox l = (ComboBox)c[0];
                l.Items.Add(column);
                l.SelectedIndex = 0;
            }
        }
        private void LoadFileTh()
        {
            try
            {
                is_running = true;
                tbl = null;
                tbl = iofunctions.ReadFileToDT((string)par[0], (char)par[1], (bool)par[2]);
            }
            catch (Exception ex)
            {
                Globals.Log(ex);
                dataGridView_file_preview.DataSource = null;
                MessageBox.Show("Wystpi problem z wczytaniem pliku.\nSprwd czy plik jest poprawny i czy nie jest uywany przez inny program.");
            }
            finally
            {
                is_running = false;
            }
        }

        private void lst_delim_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (txt_fielname.Text != "")
                LoadFile();
        }

        private void lst_header_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (txt_fielname.Text != "")
                LoadFile();
        }

        private void tabControl1_Resize(object sender, EventArgs e)
        {
            dataGridView_file_preview.Width = tabControl1.Width - dataGridView_file_preview.Location.X - 10;
            dataGridView_file_preview.Height = tabControl1.Height - dataGridView_file_preview.Location.Y - 50;
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (is_import_running)
                tabControl1.SelectedIndex = 3;
            else
            {
                label18.Visible = false;
                label19.Visible = false;
                progressBar1.Visible = false;
                pictureBox1.Visible = false;
                dataGrid_import_bad_rows.DataSource = null;
                dataGrid_import_bad_rows.Visible = false;
                button2.Enabled = true;
            }
            if (tabControl1.SelectedIndex != 0 && dataGridView_file_preview.Rows.Count == 0)
            {
                tabControl1.SelectedIndex = 0;
                return;
            }
            if (tabControl1.SelectedIndex == 2) //adowanie
            {
                if (!all_columns_passed())
                    tabControl1.SelectedIndex = 1;
            }
        }

        private bool all_columns_passed()
        {
            if (l1.SelectedIndex <= 0 || l2.SelectedIndex <= 0 || l3.SelectedIndex <= 0)
            {
                lbl_error_columnts_passed.Visible = true;
                return false;
            }
            lbl_error_columnts_passed.Visible = false;
            return true;
        }
        private void button2_Click(object sender, EventArgs e)
        {
            DateTime dt_start = DateTime.Now;
            is_import_running = true;
            label18.Visible = true;
            label18.Text = string.Format(label18.Text, 0, 0);
            progressBar1.Maximum = 100;
            progressBar1.Visible = true;
            tbl_err = tbl.Clone();
            tbl_err.Columns.Add(new DataColumn("ERROR", System.Type.GetType("System.String")));
            try
            {
                int row = 0;
                SMSObject sms = null;
                ArrayList sms_list = new ArrayList();

                foreach (DataRow dr in tbl.Rows)
                {
                    row++;
                    sms = new SMSObject();
                    string from = dr[l1.SelectedItem.ToString()].ToString().Trim();
                    if (from.Length > 11)
                    {
                        BadRowAdd(ref tbl_err, dr, string.Format("Nipoprawny tekst w polu nadawcy"));
                        continue;
                    }
                    string odbiorca = dr[l2.SelectedItem.ToString()].ToString().Trim().Replace("+", "");
                    if (odbiorca.Length != 9 && odbiorca.Length != 11)
                    {
                        BadRowAdd(ref tbl_err, dr, string.Format("Niprawidowa dugo numer udbiorcy."));
                        continue;
                    }
                    string tresc = dr[l3.SelectedItem.ToString()].ToString().Trim().Replace("\r", "").Replace("\n", "");
                    if (tresc.Length > 160)
                    {
                        BadRowAdd(ref tbl_err, dr, string.Format("Tre powyej 160 znakw"));
                        continue;
                    }
                    string delivdate = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
                    if (l7.SelectedItem.ToString() != "<ignoruj>")
                    {
                        if (!isDateTime(dr[l7.SelectedItem.ToString()].ToString().Trim()))
                        {
                            BadRowAdd(ref tbl_err, dr, string.Format("Nipoprawny data dostarczenia: " + dr[l7.SelectedItem.ToString()].ToString().Trim()));
                            continue;
                        }
                        else
                            delivdate = dr[l7.SelectedItem.ToString()].ToString().Trim();
                    }
                    sms.from = from;
                    sms.to = odbiorca;
                    sms.txt = tresc;
                    sms.smsid = row.ToString();
                    sms.delivdate = delivdate;
                    sms_list.Add(sms);
                    if (sms_list.Count == 201)
                        SendSMSArray(ref sms_list);
                    progressBar1.Value = (row * 100 / tbl.Rows.Count);
                    label18.Text = string.Format("Przetworzono {0} z {1} rekordw", row, tbl.Rows.Count);
                    Application.DoEvents();

                }
                int i = 0;
                bool ok=false;
                while (i < 3 && !ok)
                {
                    try
                    {
                        SendSMSArray(ref sms_list);
                    }
                    catch (Exception ex_s)
                    {
                        Globals.Log(ex_s);
                    }
                }
                Application.DoEvents();
                label18.Text = string.Format("Zaadowano {0} z {1} rekordw", row - tbl_err.Rows.Count, tbl.Rows.Count);
            }
            catch (Exception ex)
            {
                Globals.Log(ex);
            }

            if (tbl_err.Rows.Count == 0)//zakoczono wszystkie
            {
                dataGrid_import_bad_rows.DataSource = null;
                dataGridView_file_preview.DataSource = null;
                label19.Visible = false;
                pictureBox1.Visible = false;
                dataGrid_import_bad_rows.Visible = false;
                MessageBox.Show("zaadowano pomylnie wszystkie");
            }
            else
            {
                dataGrid_import_bad_rows.DataSource = tbl_err;
                label19.Visible = true;
                pictureBox1.Visible = true;
                dataGrid_import_bad_rows.Visible = true;
                MessageBox.Show(string.Format("Zaadowano {0} rekordw. {1} rekordw zawierao bdy!", tbl.Rows.Count - tbl_err.Rows.Count, tbl_err.Rows.Count));
            }
            button2.Enabled = true;
            is_import_running = false;
        }
        private bool isDateTime(string datetime)
        {
            try
            {
                DateTime.Parse(datetime);
                return true;
            }
            catch
            {
                return false;
            }
        }
        private void SendSMSArray(ref ArrayList sms_list)
        {
            SMSSender s = ((Globals.SSLRequired) ? s = Globals.SMS_ssl() : s = Globals.SMS());

            SMSObject[] sms_arr = new SMSObject[sms_list.Count];
            for (int i = 0; i < sms_list.Count; i++)
                sms_arr[i] = (SMSObject)sms_list[i];
            RetObject[] ret= s.SMSSendObjectArray(Globals.Username, Globals.Password, sms_arr);
            foreach (RetObject r in ret)
            {
                if (r.Status != 1)
                {
                    BadRowAdd(ref tbl_err, tbl.Rows[int.Parse(r.smsid)-1], r.Description);
                }
            }
            sms_list = new ArrayList();
        }
        private void pictureBox1_Click(object sender, EventArgs e)
        {
            iofunctions.SaveToFileDT(((DataTable)this.dataGrid_import_bad_rows.DataSource), char.Parse(";"), "sms_import_errors.csv");
        }

        private void BadRowAdd(ref DataTable tbl_err, DataRow bad_row, string powod)
        {
            object[] bad_org = bad_row.ItemArray;
            DataRow dr = tbl_err.NewRow();
            for (int i = 0; i < bad_org.Length; i++)
                dr[i] = bad_org[i];
            dr[tbl_err.Columns.Count - 1] = powod;
            tbl_err.Rows.Add(dr);
        }

    }
}