using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using System.Data;
using System.Windows.Forms;

namespace SMSManager
{
    class iofunctions
    {

        public static DataTable ReadFileToDT(string file, char delimiter, bool headers_row)
        {
            bool headers = headers_row;
            if (file.Trim() == string.Empty)
                throw new Exception("Bad file name");

            DataTable tbl = new DataTable();
            DataColumn tblkol;
            DataRow tblrow;
            int ColCount = 0, i = 0;

            System.IO.StreamReader re = new System.IO.StreamReader(file, System.Text.Encoding.Default);

            string input, txt = null;
            Regex reg = new Regex("\"(?<number>\\w+)" + delimiter.ToString() + "{1,}[ ]{0,1}(?<number2>\\w+)\"");
            MatchCollection mats;

            while ((input = re.ReadLine()) != null)
            {
                if (input.Trim().Length > 0)
                {
                    mats = reg.Matches(input);
                    tblrow = tbl.NewRow();
                    foreach (Match mat in mats)
                    {
                        string dfa = mat.ToString();
                        if (delimiter.ToString() == ",")
                        {
                            txt = mat.Groups["number"].Value.ToString() + "; " + mat.Groups["number2"].Value.ToString();
                            txt = txt.Replace(",", "; ");
                        }
                        else if (delimiter.ToString() == ";")
                        {
                            txt = mat.Groups["number"].Value.ToString() + ", " + mat.Groups["number2"].Value.ToString();
                            txt = txt.Replace(";", ", ");
                        }
                        txt = txt.Replace("\"", "");
                        input = input.Replace(mat.ToString(), txt);
                    }
                    string[] inpArr = input.Split(delimiter);
                    for (int z = 0; z < inpArr.Length; z++)
                    {
                        string inp = inpArr[z];
                        inp = inp.TrimStart(char.Parse("\""));
                        inp = inp.TrimEnd(char.Parse("\""));
                        inpArr[z] = inp;
                    }
                    if (i == 0)
                    {
                        for (int y = 0; y < inpArr.Length; y++)
                        {
                            ColCount = inpArr.Length;
                            tblkol = new DataColumn();
                            if (headers)
                                tblkol.ColumnName = inpArr[y].ToString().Trim();
                            else //jeli nie ma wiersza kolumn
                            {
                                tblkol.ColumnName = "Col_" + (y + 1).ToString();
                                i++;
                            }
                            tblkol.DataType = System.Type.GetType("System.String");
                            tbl.Columns.Add(tblkol);
                            tblkol = null;
                        }
                    }
                    if (i > 0)
                    {
                        for (int y = 0; y < inpArr.Length; y++)
                        {
                            if (tblrow.ItemArray.Length <= y)
                                break;
                            if (y <= ColCount)
                                tblrow[y] = inpArr[y];
                        }
                        tbl.Rows.Add(tblrow);
                        tblrow = null;
                    }
                    i++;
                }
            }
            re.Close();
            return tbl;
        }
        public static void SaveToFileDT(DataTable dt, char delimiter)
        {
            SaveToFileDT(dt, delimiter, "sms.csv");
        }
        public static void SaveToFileDT(DataTable dt, char delimiter,string defaultfilename)
        {
            SaveFileDialog sd = new SaveFileDialog();
            sd.Filter = "plik csv (*.csv)|*.csv";
            sd.FileName = defaultfilename;
            string FileName;
            if (sd.ShowDialog() == DialogResult.OK)
            {
                FileName = sd.FileName;
            }
            else
            {
                MessageBox.Show("Anulowano zapis!");
                return;
            }
            SaveToFileDT(dt, FileName, delimiter);
        }
        public static void SaveToFileDT(DataTable dt, string file, char delimiter)
        {
            string FileName = file;
            Globals.SetStatusText("Zapisywanie do pliku");
            Globals.ProgressBarShow(1);
            StringBuilder sb = new StringBuilder();
            int f = 0;
            foreach (DataColumn dc in dt.Columns)
            {
                if (!dc.ColumnName.StartsWith("_"))
                {
                    if (f > 0)
                        sb.Append(delimiter.ToString());
                    sb.Append("\"" + dc.ColumnName + "\"");
                    f++;
                }
            }
            sb.Append("\r\n");
            int row = 1;
            foreach (DataRow dr in dt.Rows)
            {
                f = 0;
                foreach (DataColumn dc in dt.Columns)
                {
                    if (!dc.ColumnName.StartsWith("_"))
                    {
                        if (f > 0)
                            sb.Append(delimiter.ToString());
                        sb.Append("\"" + dr[dc.ColumnName].ToString() + "\"");
                        f++;
                    }

                }
                sb.Append("\r\n");
                if (row % 10 == 0)
                    Globals.ProgressBarShow(row);
            }
            System.IO.TextWriter tw = new System.IO.StreamWriter(FileName, false, Encoding.Default);
            tw.Write(sb.ToString());
            tw.Close();
            sb = null;
            Globals.ProgressBarShow(row);
            Globals.SetStatusText("Gotowe");
            MessageBox.Show("Zapisano dane do pliku `" + FileName + "`!");
        }
    }
}